function labelgroup = labelpicimp(source, savefilename, step)

ls = source;
frame = ls.next_frame();
boxes = ls.get_boxes();

time_count = 0;
is_forward = 1;

draw_btn = 1;   % LeftButton
del_btn = 3;    % RightButton
next_btn = 29;  % LeftArrow
pre_btn = 28;   % RightArrow
exit_btn = 27;  % Esc
rev_btn = 113;  % q
go_btn = 9;     % Tab
sav_btn = 100;  % s

while 1
    
    time_count = time_count + 1;
    if time_count == 10
        time_count = 0;
        save(savefilename, 'ls');
    end
    
    show_frame(frame, boxes, ls, is_forward, step);
    
    [x, y, z] = ginput(1);
    if z == 1
        [x1, y1, z1] = ginput(1);
        if z1 == draw_btn
            x2 = [x; x1];
            y2 = [y; y1];
            [r, c, cl] = size(frame.image);
            x2(x2 < 1) = 1;
            y2(y2 < 1) = 1;
            x2(x2 > c) = c;
            y2(y2 > r) = r;
            ls.append_box(x2, y2);
            boxes = ls.get_boxes();
        end
    elseif z == del_btn
        ls.delete_box();
        boxes = ls.get_boxes();
        show_frame(frame, boxes, ls,is_forward, step);
    elseif z == pre_btn
        frame = ls.pre_frame();
        boxes = ls.get_boxes();
    elseif z == next_btn
        frame = ls.next_frame();
        boxes = ls.get_boxes();
    elseif z == rev_btn
        is_forward = abs(1 - is_forward);
    elseif z == sav_btn
        save(savefilename, 'ls');
    elseif z == go_btn
        if is_forward
            for i = 1 : step
                frame = ls.next_frame();
                boxes = ls.get_boxes();
                show_frame_pause(frame, boxes, ls, is_forward, step);
            end
        else
            for i = 1 : step
                frame = ls.pre_frame();
                boxes = ls.get_boxes();
                show_frame_pause(frame, boxes, ls, is_forward, step);
            end
        end
    elseif z == exit_btn
        labelgroup = ls;
        save(savefilename, 'ls');
%        ls.save_label();
        break;
    end
end
end


function show_frame_pause(frame, boxes, ls, is_forward, step)
    imshow(drawboxes(frame.image, boxes));
    disp(['Filename: ', frame.file_name, '  Labelled: ', num2str(ls.get_labelled_count()), '  Position: ', ... 
            num2str(ls.get_now_pos()), '/', num2str(ls.get_total_count()), ' Forward: ', num2str(is_forward), ...
            ' Step: ', num2str(step)]);
    pause(0.1);
end

function show_frame(frame, boxes, ls, is_forward, step)
    imshow(drawboxes(frame.image, boxes));
    disp(['Filename: ', frame.file_name, '  Labelled: ', num2str(ls.get_labelled_count()), '  Position: ', ... 
            num2str(ls.get_now_pos()), '/', num2str(ls.get_total_count()), ' Forward: ', num2str(is_forward), ...
            ' Step: ', num2str(step)]);
end