classdef labelsource < handle
    properties
        now_pos
        labelled_count
        file_path
        file_names
        file_package
    end
    
    methods
        function obj = labelsource(picpath)
            obj.file_path = picpath;
            obj.now_pos = 0;
            obj.labelled_count = 0;
            file_package_pos = 0;
            dict = dir(picpath);
%            old_var = 0;
            for ii = 1 : length(dict)
                cur_name = dict(ii).name;
                if length(cur_name) > 4
                    
%                     prefix = cur_name(1 : length(cur_name) - 4);
%                     new_var = str2num(prefix);
%                     if new_var - old_var > 1
%                         new_var
%                     end
%                     old_var = new_var;
                    
                    postfix = cur_name(length(cur_name) - 2 : length(cur_name));
                    if strcmpi(postfix, 'jpg') == 1 || strcmpi(postfix, 'bmp') == 1
                        file_package_pos = file_package_pos + 1;
                        obj.file_package(file_package_pos).file_name = cur_name;
                        obj.file_package(file_package_pos).boxes(1) = struct('x', 0, 'y', 0, 'w', 0, 'h', 0);
                    end
                end
            end
         end
        
        function frame = next_frame(obj)
            if obj.now_pos < length(obj.file_package)
                 obj.now_pos = obj.now_pos + 1;
            end
            file_path = strcat(obj.file_path, '\', obj.file_package(obj.now_pos).file_name);
%             file_path
            frame.file_name = obj.file_package(obj.now_pos).file_name;
            frame.image = imread(file_path);
            
            frame.boxes = obj.file_package(obj.now_pos).boxes;
        end
        
        function frame = pre_frame(obj)
            if obj.now_pos > 1
                obj.now_pos = obj.now_pos - 1;
            end
            file_path = strcat(obj.file_path, '/', obj.file_package(obj.now_pos).file_name);
            frame.file_name = obj.file_package(obj.now_pos).file_name;
            frame.image = imread(file_path);
            frame.boxes = obj.file_package(obj.now_pos).boxes;
        end
        
        function frame = get_frame(obj, pos)
            file_path = strcat(obj.file_path, '/', obj.file_package(pos).file_name);
            frame.file_name = obj.file_package(pos).file_name;
            frame.image = imread(file_path);
            frame.boxes = obj.file_package(pos).boxes;
        end
        
        function frame = get_cur_frame(obj)
            file_path = strcat(obj.file_path, '/', obj.file_package(obj.now_pos).file_name);
            frame.file_name = obj.file_package(obj.now_pos).file_name;
            frame.image = imread(file_path);
            frame.boxes = obj.file_package(obj.now_pos).boxes;
        end
        
        function append_box(obj, x, y)
            ix = round(x);
            iy = round(y);
            box_pos = length(obj.file_package(obj.now_pos).boxes) + 1;
            obj.file_package(obj.now_pos).boxes(box_pos) = struct('x', min(ix), ...
                'y', min(iy), 'w', abs(ix(1)-ix(2)), 'h', abs(iy(1)-iy(2)));
            if length(obj.file_package(obj.now_pos).boxes) == 2
                obj.labelled_count = obj.labelled_count + 1;
            end
        end
        
        function boxes = get_boxes(obj)
            boxes = obj.file_package(obj.now_pos).boxes;
        end
        
        function delete_box(obj)
            box_pos = length(obj.file_package(obj.now_pos).boxes);
            if box_pos > 1
                obj.file_package(obj.now_pos).boxes = ...
                    obj.file_package(obj.now_pos).boxes(1 : box_pos - 1);
            end
            if box_pos == 2
                obj.labelled_count = obj.labelled_count - 1;
            end
        end
        
        function len = frame_count(obj)
            len = length(obj.file_names);
        end
        
        function rt = reach_end(obj)
            rt = (obj.now_pos == length(obj.file_package));
        end
        
        function rt = reach_begin(obj)
            rt = (obj.now_pos == 1);
        end
        
        function reset(obj)
            obj.now_pos = 0;
        end
        
        function pos = get_now_pos(obj)
            pos = obj.now_pos;
        end
        
        function cnt = get_total_count(obj)
            cnt = length(obj.file_package);
        end
        
        function cnt = get_labelled_count(obj)
            cnt = obj.labelled_count;
        end
        
        function save_label(obj)
        end
  
    end
end